﻿package
{
	import flash.display.DisplayObject;
	import flash.display.Sprite;
	import flash.display.MovieClip;
	import flash.display.Stage;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.ui.Mouse;
	import flash.geom.Rectangle;
	import flash.display.Graphics;
	import flash.display.Shape;

	public class Triangler extends Sprite
	{
		
		private var stack:Array;
		private var max:Number = 90;
		private var maxAngle:Number = 10;
		private var forme:MovieClip;
		private var forme2:MovieClip;
		private var posX:Number;
		private var posY:Number;
		private var lineSize:Number;
		
		private var _shapeSource:Shape;
        private var _shapeCourante:Shape;
        private var _spriteConteneur:Sprite;
		private static const THICKNESS:uint = 1;
        private static const COLOR:uint = 0xFF0000;
        private static const NB_ECART_ROTATION:uint = 12;
        private static const ROTATION:uint = 360 / NB_ECART_ROTATION;


		
		public function Triangler()
		{
			stack = new Array();
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
		}
		
		private function addedHandler(e:Event):void
		{
			stage.addEventListener(MouseEvent.MOUSE_DOWN, downHandler);
			stage.addEventListener(MouseEvent.MOUSE_UP, upHandler);
			creer();

		}
		
		private function downHandler(e:MouseEvent):void
		{
			lineSize = (Math.random()*15)+3;
			forme = new MovieClip();
			posX = e.stageX;
			posY = e.stageY;
			forme.x = posX;
			forme.y = posY;
			addChild(forme);
			stack[0] = new Point(mouseX,mouseY);
			stack[1] = new Point(mouseX,mouseY);
			this._shapeSource.graphics.lineStyle(lineSize,Math.random()*0xffffff,1);
			this._shapeSource.graphics.moveTo(mouseX-posX,mouseY-posY);
			stage.addEventListener(MouseEvent.MOUSE_MOVE, moveHandler);
			
		}
		
		private function upHandler(e:MouseEvent):void
		{
			stage.removeEventListener(MouseEvent.MOUSE_MOVE, moveHandler);
			
			for (var i:Number = ROTATION; i < 360; i += ROTATION)
				{
					this._shapeCourante = new Shape();
					this._spriteConteneur.addChild(this._shapeCourante);
					this._shapeCourante.rotation = i;
					this._shapeCourante.graphics.copyFrom(this._shapeSource.graphics);
				}

		}
		private function moveHandler(e:MouseEvent):void
		{
			stack[1].x = e.stageX-posX;
			stack[1].y = e.stageY-posY;
			if(Point.distance(stack[0],stack[1])>=max && checkAngle()%maxAngle<=1){
				stack[0].x = stack[1].x;
				stack[0].y = stack[1].y;
				this._shapeSource.graphics.lineTo(stack[1].x,stack[1].y);

			}
		}
		
		private function creer():void
        {
            // conteneur
            if( this._spriteConteneur )
                this.removeChild(this._spriteConteneur);
            this._spriteConteneur = new Sprite();
            this._spriteConteneur.x = stage.stageWidth / 2;
            this._spriteConteneur.y = stage.stageHeight / 2;
            this.addChild(this._spriteConteneur);
 
            // Shape dont les données de dessin seront dupliqués
            this._shapeSource = new Shape();
            this._shapeSource.graphics.lineStyle(THICKNESS, COLOR);
            this._spriteConteneur.addChild(this._shapeSource);
        }
		
		private function checkAngle():Number
		{
			var dx = stack[1].x - stack[0].x;
			var dy = stack[1].y - stack[0].y;
			
			var reponse = Math.round(Math.atan2(dx,dy)* 180 / Math.PI);
			//trace(reponse);
			return reponse;
		}
		
	}
}